/*    
   Disclaimers
   ALL INFORMATION PROVIDED WITHIN OR OTHERWISE ASSOCIATED WITH THIS 
   PUBLICATION  INCLUDING, INTER ALIA, ALL SOFTWARE CODE, IS PROVIDED
   "AS IS, AND FOR EDUCATIONAL PURPOSES ONLY. INTEL RETAINS ALL 
   OWNERSHIP INTEREST IN ANY INTELLECTUAL PROPERTY RIGHTS ASSOCIATED 
   WITH THIS INFORMATION AND NO LICENSE, EXPRESS OR IMPLIED, BY 
   ESTOPPEL OR OTHERWISE, TO ANY INTELLECTUAL PROPERTY RIGHT IS GRANTED
   BY THIS PUBLICATION OR AS A RESULT OF YOUR PURCHASE THEREOF. INTEL 
   ASSUMES NO LIABILITY WHATSOEVER AND INTEL DISCLAIMS ANY EXPRESS OR 
   IMPLIED WARRANTY RELATING TO THIS INFORMATION INCLUDING, BY WAY OF 
   EXAMPLE AND NOT LIMITATION, LIABILITY OR WARRANTIES RELATING TO 
   FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABILITY, OR THE INFRINGEMENT
   OF ANY INTELLECTUAL PROPERTY RIGHT ANYWHERE IN THE WORLD.


   THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS AND ANY EXPRESS OR 
   IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
   WARRANTIES    OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
   ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
   INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
   IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
   POSSIBILITY OF SUCH DAMAGE.
*/
/*
   Lab 4.1: Endian-Neutral Code Using Compiler-Directed Byte Swapping:
   The following program assumes big-endian memory architecture. Modify 
   the code so that it uses byte swapping and compiler directive to
   transform the code to be endian-neutral. The code must initialize a
   short variable one byte at a time, to the value of 0x1234, and print
   out the whole value in its natural data type. The endian-neutral code
   should print out the same results whether the code is compiled for
   and executed on big- or little-endian architecture.

   The result should execute and print as follows:
      > 1234
*/


#include <stdio.h>
#define SWAP_TWO_BYTES(X) (((X & 0xff00) >> 8) | ((X & 0x00ff) << 8))

int main()
{
    short Val;
    char *pVal;
    pVal = (char *) &Val;

    /*
    The following two lines assume big-endian
    Architecture to initialize the variable Val
    to 0x1234.
    */
    pVal[0] = 0x12;
    pVal[1] = 0x34;

#ifdef BIG_ENDIAN
    ; /* do nothing */
#else
    Val = SWAP_TWO_BYTES (Val);
#endif
    printf("%x\n", Val);
    return (0);
}
